------------------------------------------------------------------------------
-- Beispielskript zur AEK 20 im Oktober 2017 in Nrnberg und Hannover
-- Autor: Bernd Jungbluth
-- Keine Gewhrleistung, keine Haftung

-- Anlegen einer XEVENT-Sitzung zur Protokollierung von Sperren und Wartetypen
------------------------------------------------------------------------------

-- Protokollierung von Sperren aktivieren
EXEC sp_configure 'Show Advanced Options', 1
RECONFIGURE
EXEC sp_configure 'blocked process threshold (s)', 1
RECONFIGURE
EXEC sp_configure 'Show Advanced Options', 0
RECONFIGURE

-- Sitzung lschen, falls bereits vorhanden
IF EXISTS(SELECT * FROM sys.server_event_sessions WHERE name='Sperren und Wartetypen')
BEGIN
	DROP EVENT SESSION [Sperren und Wartetypen] ON SERVER;
END
GO

-- Sitzung anlegen
CREATE EVENT SESSION [Sperren und Wartetypen] ON SERVER 
	ADD EVENT sqlos.wait_info(
		ACTION	(package0.event_sequence, sqlserver.client_app_name, sqlserver.client_hostname,
				 sqlserver.database_id, sqlserver.database_name, sqlserver.is_system,
				 sqlserver.nt_username, sqlserver.plan_handle, sqlserver.session_id,
				 sqlserver.session_nt_username, sqlserver.sql_text, sqlserver.username)
		WHERE	(sqlserver.database_id = 11 
				 AND 
				 sqlserver.is_system = 0)),
	ADD EVENT	sqlserver.lock_acquired
				(SET collect_resource_description = 1
				 ACTION	(package0.event_sequence, sqlserver.client_app_name, sqlserver.client_hostname,
						 sqlserver.database_id, sqlserver.database_name, sqlserver.is_system,
						 sqlserver.nt_username, sqlserver.plan_handle, sqlserver.session_id,
						 sqlserver.session_nt_username, sqlserver.sql_text, sqlserver.username)
				 WHERE	(sqlserver.database_id = 11 
						 AND 
						 sqlserver.is_system = 0)),
	ADD EVENT	sqlserver.lock_timeout
				(SET collect_resource_description = 1
				 ACTION	(package0.event_sequence, sqlserver.client_app_name, sqlserver.client_hostname,
						 sqlserver.database_id, sqlserver.database_name, sqlserver.is_system,
						 sqlserver.nt_username, sqlserver.plan_handle, sqlserver.session_id,
						 sqlserver.session_nt_username, sqlserver.sql_text, sqlserver.username)
				 WHERE	(sqlserver.database_id = 11 
						 AND 
						 sqlserver.is_system = 0)),
	ADD EVENT	sqlserver.blocked_process_report(
				ACTION	(package0.event_sequence, sqlserver.client_app_name, sqlserver.client_hostname,
						 sqlserver.database_id, sqlserver.database_name, sqlserver.is_system,
						 sqlserver.nt_username, sqlserver.plan_handle, sqlserver.session_id,
						 sqlserver.session_nt_username, sqlserver.sql_text, sqlserver.username))
ADD TARGET	package0.event_file
			(SET filename = N'D:\AEK 20\SQL Server\XEvents\Sperren und Wartetypen.xel')
-- Latenzzeit aus Demozwecken auf 10 Sekunden
WITH (MAX_DISPATCH_LATENCY=10 SECONDS);
GO